function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _async_to_generator(fn) {
  return function() {
    var self = this, args = arguments;
    return new Promise(function(resolve, reject) {
      var gen = fn.apply(self, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(void 0);
    });
  };
}
function _class_call_check(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor)
      descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}
function _create_class(Constructor, protoProps, staticProps) {
  if (protoProps)
    _defineProperties(Constructor.prototype, protoProps);
  if (staticProps)
    _defineProperties(Constructor, staticProps);
  return Constructor;
}
function _define_property(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _object_spread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);
    if (typeof Object.getOwnPropertySymbols === "function") {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }
    ownKeys.forEach(function(key) {
      _define_property(target, key, source[key]);
    });
  }
  return target;
}
var __generator = function(thisArg, body) {
  var f, y, t, g, _ = {
    label: 0,
    sent: function() {
      if (t[0] & 1)
        throw t[1];
      return t[1];
    },
    trys: [],
    ops: []
  };
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
    return this;
  }), g;
  function verb(n) {
    return function(v) {
      return step([
        n,
        v
      ]);
    };
  }
  function step(op) {
    if (f)
      throw new TypeError("Generator is already executing.");
    while (_)
      try {
        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
          return t;
        if (y = 0, t)
          op = [
            op[0] & 2,
            t.value
          ];
        switch (op[0]) {
          case 0:
          case 1:
            t = op;
            break;
          case 4:
            _.label++;
            return {
              value: op[1],
              done: false
            };
          case 5:
            _.label++;
            y = op[1];
            op = [
              0
            ];
            continue;
          case 7:
            op = _.ops.pop();
            _.trys.pop();
            continue;
          default:
            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
              _ = 0;
              continue;
            }
            if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
              _.label = op[1];
              break;
            }
            if (op[0] === 6 && _.label < t[1]) {
              _.label = t[1];
              t = op;
              break;
            }
            if (t && _.label < t[2]) {
              _.label = t[2];
              _.ops.push(op);
              break;
            }
            if (t[2])
              _.ops.pop();
            _.trys.pop();
            continue;
        }
        op = body.call(thisArg, _);
      } catch (e) {
        op = [
          6,
          e
        ];
        y = 0;
      } finally {
        f = t = 0;
      }
    if (op[0] & 5)
      throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
};
import { FS_RESOURCE } from "@modern-js/codesmith";
import { renderString } from "./utils";
export { renderString };
export var EjsAPI = /* @__PURE__ */ function() {
  "use strict";
  function EjsAPI2(generatorCore) {
    _class_call_check(this, EjsAPI2);
    _define_property(this, "generatorCore", void 0);
    this.generatorCore = generatorCore;
  }
  _create_class(EjsAPI2, [
    {
      key: "renderTemplate",
      value: function renderTemplate(templateResource, target) {
        var parameters = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
        var _this = this;
        return _async_to_generator(function() {
          var resourceValue;
          return __generator(this, function(_state) {
            switch (_state.label) {
              case 0:
                if (templateResource._type !== FS_RESOURCE) {
                  throw new Error("resource not match");
                }
                return [
                  4,
                  templateResource.value()
                ];
              case 1:
                resourceValue = _state.sent();
                if (typeof resourceValue.content !== "string") {
                  throw new Error("resource.value is not string, resourceValue=".concat(resourceValue));
                }
                return [
                  4,
                  _this.generatorCore.output.fs(target, renderString(resourceValue.content, parameters), {
                    encoding: "utf-8"
                  })
                ];
              case 2:
                _state.sent();
                return [
                  2
                ];
            }
          });
        })();
      }
    },
    {
      key: "renderTemplateDir",
      value: function renderTemplateDir(material, findGlob, target, options) {
        var _this = this;
        return _async_to_generator(function() {
          var resourceMap;
          return __generator(this, function(_state) {
            switch (_state.label) {
              case 0:
                return [
                  4,
                  material.find(findGlob, _object_spread({
                    nodir: true
                  }, options))
                ];
              case 1:
                resourceMap = _state.sent();
                return [
                  4,
                  Promise.all(
                    // resourceKey is relate path. example: in `garr-master/package.json`, package.json is resourceKey
                    Object.keys(resourceMap).map(function() {
                      var _ref = _async_to_generator(function(resourceKey) {
                        return __generator(this, function(_state2) {
                          switch (_state2.label) {
                            case 0:
                              _this.generatorCore.logger.debug("[renderDir] resourceKey=".concat(resourceKey));
                              return [
                                4,
                                _this.renderTemplate(material.get(resourceKey), target(resourceKey), options === null || options === void 0 ? void 0 : options.parameters)
                              ];
                            case 1:
                              _state2.sent();
                              return [
                                2
                              ];
                          }
                        });
                      });
                      return function(resourceKey) {
                        return _ref.apply(this, arguments);
                      };
                    }())
                  )
                ];
              case 2:
                _state.sent();
                return [
                  2
                ];
            }
          });
        })();
      }
    }
  ]);
  return EjsAPI2;
}();
